Partial Class ADXPowerPointTaskPane1
    Inherits AddinExpress.PP.ADXPowerPointTaskPane
    Implements Logging.ILogPane

    Private letMeShow As Boolean = True
    Shared _ID As Integer = 0
    Private id As Integer = 0

    Public Sub New()
        InitializeComponent()
        id = Math.Min(System.Threading.Interlocked.Increment(_ID), _ID - 1)
        Logging.Log.Add(Me.ToString, "New instance created")
        ' Me.logPaneManager = MyAddin1.AddinModule.CurrentInstance as Logging.ILogPaneManager
        Me.label1.Text = "Id=" & id.ToString()
    End Sub

#Region "Events of Add-in Express panes"
    Private Sub ADXPowerPointTaskPane1_ADXBeforeTaskPaneShow(ByVal sender As Object, ByVal e As AddinExpress.PP.ADXBeforeTaskPaneShowEventArgs) Handles MyBase.ADXBeforeTaskPaneShow
        Me.logPaneManager = TryCast(Me.AddinModule, Logging.ILogPaneManager)
        Me.Visible = letMeShow

        If Not letMeShow Then
            Logging.Log.Add(Me.ToString, "ADXBeforeTaskPaneShow. Pane won't show.")
        End If
    End Sub

    Private Sub ADXPowerPointTaskPane1_ADXAfterTaskPaneShow(ByVal sender As Object, ByVal e As AddinExpress.PP.ADXAfterTaskPaneShowEventArgs) Handles MyBase.ADXAfterTaskPaneShow
        Logging.Log.Add(Me.ToString, "ADXPowerPointTaskPane1_ADXAfterTaskPaneShow")
        logPaneManager.PaneVisibilityChanged(Me) ' updates Ribbon controls showing/hiding the pane

        Me.listBox1.Items.Clear()
        Dim lastIndex As Integer = -1

        For Each item As Logging.LogRecord In logPaneManager.GetRecords()
            lastIndex = Me.listBox1.Items.Add(item.ToString())
        Next

        If lastIndex >= 0 Then listBox1.SelectedIndex = lastIndex
        AddHandler logPaneManager.NewLogData, AddressOf LogManager_NewLogData
        Logging.Log.Add(Me.ToString, "ADXPowerPointTaskPane1_ADXAfterTaskPaneShow." & lastIndex.ToString() & " log records proccessed")
    End Sub

    Private Sub ADXPowerPointTaskPane1_ADXCloseButtonClick(ByVal sender As Object, ByVal e As AddinExpress.PP.ADXCloseButtonClickEventArgs) Handles MyBase.ADXCloseButtonClick
        Logging.Log.Add(Me.ToString, "User closed the pane")
        letMeShow = False
    End Sub

    Private Sub ADXPowerPointTaskPane1_ADXAfterTaskPaneHide(ByVal sender As Object, ByVal e As AddinExpress.PP.ADXAfterTaskPaneHideEventArgs) Handles MyBase.ADXAfterTaskPaneHide
        RemoveHandler logPaneManager.NewLogData, AddressOf LogManager_NewLogData
        Logging.Log.Add(Me.ToString, "ADXAfterTaskPaneHide")
        logPaneManager.PaneVisibilityChanged(Me) ' updates Ribbon controls showing/hiding the pane
    End Sub
#End Region

#Region "Log event"
    Private Sub LogManager_NewLogData(ByVal sender As Object, ByVal e As Logging.LogRecord)
        Me.listBox1.Items.Add(e.ToString())
    End Sub
#End Region

#Region "Clear and Copy"
    Private Sub buttonClear_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonClear.Click
        Logging.Log.Add(Me.ToString, "buttonClear_Click")
        Me.listBox1.Items.Clear()
    End Sub

    Private Sub buttonCopy_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonCopy.Click
        Logging.Log.Add(Me.ToString, "buttonCopy_Click")
        System.Windows.Forms.Clipboard.SetText(listBox1.Items(listBox1.SelectedIndex).ToString())
    End Sub
#End Region

#Region "ILogPane implementation"
    Private logPaneManager As Logging.ILogPaneManager

    Private ReadOnly Property ILogPane_IsPaneShown As Boolean Implements Logging.ILogPane.IsPaneShown
        Get
            Return letMeShow
        End Get
    End Property

    Private Sub ILogPane_Show() Implements Logging.ILogPane.Show
        letMeShow = True
        Me.Show()
    End Sub

    Private Sub ILogPane_Hide() Implements Logging.ILogPane.Hide
        letMeShow = False
        Me.Hide()
    End Sub
#End Region

    Public Overrides Function ToString() As String
        Return "ADXPowerPointTaskPane1. id=" & id.ToString()
    End Function

End Class
